#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;

use lib ('lib');
use File::DXF::Util qw /read_DXF dxf/;
use File::DXF;

# Takes the 3d coordinates of TEXT objects in a DXF file and merges
# them with a triangle list generated by qhull qdelaunay and outputs
# a 3d triangle POLYLINE mesh DXF file.

my $filename = $ARGV[0] || die 'DXF file not specified';
my $data = read_DXF ($filename, 'CP1252');

my $triangles = $ARGV[1] || die 'triangles not specified';
open TRIANGLES, "<$triangles";
my @triangles = <TRIANGLES>;
close TRIANGLES;
shift @triangles;

my $dxf = new File::DXF;
   $dxf->Process ($data);
my $entities = $dxf->{ENTITIES};

my @report = $entities->Report (('TEXT', 'INSERT', 'POINT'));

open OUTPUT, ">$ARGV[2]" || die 'output DXF file not specified';

my $index = 0;

print OUTPUT dxf (0, 'SECTION');
print OUTPUT dxf (2, 'ENTITIES');

print OUTPUT dxf (0, 'POLYLINE');
print OUTPUT dxf (5, $index); # id
print OUTPUT dxf (8, 'MESHES'); # layer
print OUTPUT dxf (66, 1);
print OUTPUT dxf (10, '0.0'); # x
print OUTPUT dxf (20, '0.0'); # y
print OUTPUT dxf (30, '0.0'); # z
print OUTPUT dxf (70, 64);
print OUTPUT dxf (71, scalar (@report)); # no. nodes
print OUTPUT dxf (72, scalar (@triangles)); # no. triangles

for my $item (@report)
{
    print OUTPUT dxf (0, 'VERTEX'); # type
    print OUTPUT dxf (5, $index); # id
    print OUTPUT dxf (8, 'MESHES'); # layer
    print OUTPUT dxf (10, $item->Coordinates->[0]); # x
    print OUTPUT dxf (20, $item->Coordinates->[1]); # y
    print OUTPUT dxf (30, $item->Coordinates->[2]); # z
    print OUTPUT dxf (70, 192); # is a node

    $index++;
}

for my $item (@triangles)
{
    my @abc = split / +/, $item;

    print OUTPUT dxf (0, 'VERTEX'); # type
    print OUTPUT dxf (5, $index); # id
    print OUTPUT dxf (8, 'MESHES'); # layer
    print OUTPUT dxf (10, '0.0'); # x
    print OUTPUT dxf (20, '0.0'); # y
    print OUTPUT dxf (30, '0.0'); # z
    print OUTPUT dxf (70, 128); # is a triangle
    print OUTPUT dxf (71, $abc[0] + 1); # a
    print OUTPUT dxf (72, $abc[1] + 1); # b
    print OUTPUT dxf (73, $abc[2] + 1); # c

    $index++;
}

print OUTPUT dxf (0, 'SEQEND'); # type
print OUTPUT dxf (5, $index); # id
print OUTPUT dxf (8, 'MESHES'); # layer

print OUTPUT dxf (0, 'ENDSEC');

print OUTPUT dxf (0, 'EOF');

0;
