#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;

use lib ('lib');
use File::DXF::Util qw /read_DXF/;
use File::DXF;
use File::DXF::Csv;

my $filename = $ARGV[0] || die 'DXF file not specified';
my $data = read_DXF ($filename, 'CP1252');

my $dxf = new File::DXF;
   $dxf->Process ($data);
my $entities = $dxf->{ENTITIES};

{
    my @report = $entities->Report (('CIRCLE'));

    my $csv = new File::DXF::Csv;
    $csv->Push ('X', 'Y', 'Z', 'Radius', 'Diameter', 'Circumference', 'Area');

    for my $item (@report)
    {
        $csv->Push (@{$item->Coordinates},
                      $item->Radius,
                      $item->Diameter,
                      $item->Circumference,
                      $item->Area);
    }

    $csv->Write ("$filename.CIRCLE.csv");
}

{
    my @report = $entities->Report (('POINT'));

    my $csv = new File::DXF::Csv;
    $csv->Push ('X', 'Y', 'Z');

    for my $item (@report)
    {
        $csv->Push (@{$item->Coordinates});
    }

    $csv->Write ("$filename.POINT.csv");
}

{
    my @report = $entities->Report (('TEXT'));

    my $csv = new File::DXF::Csv;
    $csv->Push ('X', 'Y', 'Z', 'Content', 'Height', 'Rotation');

    for my $item (@report)
    {
        $csv->Push (@{$item->Coordinates},
                      $item->Content,
                      $item->Height,
                      $item->Rotation);
    }

    $csv->Write ("$filename.TEXT.csv");
}

0;
