#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;

use lib ('lib');
use File::DXF::Util qw /read_DXF/;
use File::DXF;
use SVG;

my $filename = $ARGV[0] || die 'DXF file not specified';
my $data = read_DXF ($filename, 'CP1252');

my $dxf = new File::DXF;
   $dxf->Process ($data);
my $entities = $dxf->{ENTITIES};

my @report = $entities->Report (('LINE'));

my $svg = new SVG (width => 1600,
                  height => 1200);

my $width = 2;
my $colour = 'rgb(0,0,0)';

for my $item (@report)
{
    my $a = $item->Coordinates (0);
    my $b = $item->Coordinates (1);
    $svg->line (x1 => $a->[0], y1 => $a->[1],
                x2 => $b->[0], y2 => $b->[1],
                style => { 'stroke-width' => $width,
                                 'stroke' => $colour });
}

open (SVGFILE, ">:utf8", $ARGV[1]);
print SVGFILE $svg->xmlify;
close SVGFILE;

0;
