#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;

use lib ('lib');
use File::DXF::Util 'read_DXF';
use File::DXF;
use File::DXF::HEADER;
use File::DXF::ENTITIES;
use File::DXF::BLOCKS;

# Merges two or more DXF files into a new DXF file, identically named blocks in
# earlier DXF files will be clobbered by those in later DXF files.
# Expect to lose data such as layers, geometry should be preserved

die "usage: $0 foo.dxf bar.dxf [...] merged.dxf" unless scalar @ARGV > 1;

my @paths = @ARGV;

my $path_out = pop @paths;
my $dxf_out = new File::DXF;
$dxf_out->{HEADER} = new File::DXF::HEADER;
$dxf_out->{ENTITIES} = new File::DXF::ENTITIES;
$dxf_out->{BLOCKS} = new File::DXF::BLOCKS;

for my $path (@paths)
{
    my $data = read_DXF ($path, 'CP1252');
    my $dxf_in = new File::DXF;
    $dxf_in->Process ($data);
    for my $key (keys %{$dxf_in->{BLOCKS}})
    {
        $dxf_out->{BLOCKS}->{$key} = $dxf_in->{BLOCKS}->{$key};
    }
    push @{$dxf_out->{ENTITIES}}, @{$dxf_in->{ENTITIES}};
}

open DXF, '>'.$path_out;
binmode DXF, ":crlf";
print DXF $dxf_out->DXF;
close DXF;

0;

