#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;

use lib ('lib');
use File::DXF::Util 'read_DXF';
use File::DXF;
use File::DXF::HEADER;
use File::DXF::ENTITIES;
use File::DXF::BLOCKS;

die "usage: $0 foo.dxf [...]" unless scalar @ARGV > 0;

# Takes one or more DXF files, extracts the block entities and writes each as a
# separate DXF file. Filenames are block names with .dxf appended

my @paths = @ARGV;

for my $path (@paths)
{
    my $data = read_DXF ($path, 'CP1252');
    my $dxf_in = new File::DXF;
    $dxf_in->Process ($data);
    for my $key (keys %{$dxf_in->{BLOCKS}})
    {
        my $dxf_out = new File::DXF;
        $dxf_out->{HEADER} = new File::DXF::HEADER;
        $dxf_out->{ENTITIES} = new File::DXF::ENTITIES;

        $dxf_out->{ENTITIES}->Process ($dxf_in->{BLOCKS}->{$key});

        my $path_out = $key .'.dxf';
        open DXF, '>'.$path_out;
        binmode DXF, ":crlf";
        print DXF $dxf_out->DXF;
        close DXF;
    }
}

0;

