#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;

use lib ('lib');
use File::DXF::Util qw /read_DXF dxf/;
use File::DXF;

my $filename = $ARGV[0] || die 'DXF file not specified';
my $data = read_DXF ($filename, 'CP1252');

my $dxf_in = new File::DXF;
   $dxf_in->Process ($data);

my @report = $dxf_in->{ENTITIES}->Report (('POLYLINE', 'VERTEX', 'SEQEND'));

my $mesh;
my $rect;
my $vertex_index;
my $state = 'INIT';

my $dxf_out = new File::DXF;
$dxf_out->{HEADER} = new File::DXF::HEADER;
$dxf_out->{ENTITIES} = new File::DXF::ENTITIES;

for my $item (@report)
{
    if ($item->Type eq 'POLYLINE' and $item->Rectangular)
    {
        $mesh = $item;
        $rect = [];
        $vertex_index = 0;
        $state = 'MESH';
    }

    if ($state eq 'MESH' and $item->Type eq 'VERTEX')
    {
        my ($i, $j) = $mesh->Index ($vertex_index);
        $rect->[$i]->[$j] = [@{$item->Coordinates}, $vertex_index +1];
        $vertex_index++;
    }

    if ($state eq 'MESH' and $item->Type eq 'SEQEND')
    {
        push @{$dxf_out->{ENTITIES}}, 
        {type => 'POLYLINE', _data => [
            [8, 0],
            [62, 0],
            [66, 1],
            [10, 0.0],
            [20, 0.0],
            [30, 0.0],
            [70, 64],
            [71, scalar (@{$rect}) * scalar (@{$rect->[0]})],
            [72, (scalar (@{$rect}) + $mesh->Closed_M) * (scalar (@{$rect->[0]}) + $mesh->Closed_N)]
        ]};

        for my $m (0 .. scalar @{$rect} -1)
        {
            for my $n (0 .. scalar @{$rect->[0]} -1)
            {

                push @{$dxf_out->{ENTITIES}}, {type => 'VERTEX', _data => [
                    [8, 0],
                    [10, $rect->[$m]->[$n]->[0]],
                    [20, $rect->[$m]->[$n]->[1]],
                    [30, $rect->[$m]->[$n]->[2]],
                    [70, 192]
                ]};
            }
        }

        for my $m (0 - $mesh->Closed_M .. scalar (@{$rect}) -2)
        {
            for my $n (0 - $mesh->Closed_N .. scalar (@{$rect->[0]}) -2)
            {
                push @{$dxf_out->{ENTITIES}}, {type => 'VERTEX', _data => [
                    [8, 0],
                    [62, 0],
                    [10, 0.0],
                    [20, 0.0],
                    [30, 0.0],
                    [62, 0],
                    [70, 128],
                    [71, $rect->[$m]->[$n]->[3]],
                    [72, $rect->[$m +1]->[$n]->[3]],
                    [73, $rect->[$m +1]->[$n +1]->[3]],
                    [74, $rect->[$m]->[$n +1]->[3]],
                ]};
            }
        }

        push @{$dxf_out->{ENTITIES}}, {type => 'SEQEND', _data => []};

        $state = 'NEXT';
    }
}

open DXF, '>'. $ARGV[1];
binmode DXF, ":crlf";
print DXF $dxf_out->DXF;
close DXF;

0;

