package File::DXF::ENTITIES::CIRCLE;

=head1 NAME

File::DXF::ENTITIES::CIRCLE - AutoCAD DXF CIRCLE entity

=head1 SYNOPSIS

This is an unfinished DXF parser

=head1 DESCRIPTION

=cut

use strict;
use warnings;

use File::DXF::ENTITIES::Entity qw /next_item pi/;

use vars qw /@ISA/;
@ISA = qw /File::DXF::ENTITIES::Entity/;

=pod

Create one like so:

  $foo = new File::DXF::ENTITIES::CIRCLE;

=cut

sub new
{
    my $class = shift;
    $class = ref $class || $class;
    my $self = { x => 0,
                 y => 0,
                 z => 0,
            radius => 0 };

    bless $self, $class;
    return $self;
}

=pod

Try and find some structure in the raw data

  $foo->Process ($data);

=cut

sub Process
{
    my $self = shift;
    my $data = shift;

    while (@{$data})
    {
        my ($code, $string) = next_item ($data);
        $self->Radius ($string) if ($code == 40);
        $self->{x}        = $string if ($code == 10);
        $self->{y}        = $string if ($code == 20);
        $self->{z}        = $string if ($code == 30);
        $self->{normal_x} = $string if ($code == 210);
        $self->{normal_y} = $string if ($code == 220);
        $self->{normal_z} = $string if ($code == 230);
    }
}

sub Radius
{
    my $self = shift;
    $self->{radius} = shift || $self->{radius};
    return $self->{radius};
}

sub Diameter
{
    my $self = shift;
    return (2 * $self->Radius);
}

sub Circumference
{
    my $self = shift;
    return (&pi * $self->Diameter);
}

sub Area
{
    my $self = shift;
    return (&pi * $self->Radius * $self->Radius);
}

1;

