package File::DXF::ENTITIES::INSERT;

=head1 NAME

File::DXF::ENTITIES::INSERT - AutoCAD DXF INSERT entity

=head1 SYNOPSIS

This is an unfinished DXF parser

=head1 DESCRIPTION

=cut

use strict;
use warnings;

use File::DXF::ENTITIES::POINT;
use File::DXF::ENTITIES::Entity 'next_item';

use vars qw /@ISA/;
@ISA = qw /File::DXF::ENTITIES::POINT/;

=pod

Try and find some structure in the raw data

  $foo->Process ($data);

=cut

sub Process
{
    my $self = shift;
    my $data = shift;

    while (@{$data})
    {
        my ($code, $string) = next_item ($data);
        $self->{name} = $string if ($code == 2);
        $self->{x} = $string if ($code == 10);
        $self->{y} = $string if ($code == 20);
        $self->{z} = $string if ($code == 30);
        $self->{rotation} = $string if ($code == 50);
        $self->{mode} = $string if ($code == 70);
    }
}

1;

