package File::DXF::ENTITIES::TEXT;

=head1 NAME

File::DXF::ENTITIES::TEXT - AutoCAD DXF TEXT entity

=head1 SYNOPSIS

This is an unfinished DXF parser

=head1 DESCRIPTION

=cut

use strict;
use warnings;
use Encode qw /decode/;

use File::DXF::ENTITIES::Entity 'next_item';
use File::DXF::Util 'decode_AutoCAD';

use vars qw /@ISA/;
@ISA = qw /File::DXF::ENTITIES::Entity/;

=pod

Create one like so:

  $foo = new File::DXF::ENTITIES::TEXT;

=cut

sub new
{
    my $class = shift;
    $class = ref $class || $class;
    my $self = {content => '',
                      x => 0,
                      y => 0,
                      z => 0,
                 height => 2.5,
               rotation => 0};

    bless $self, $class;
    return $self;
}

=pod

Try and find some structure in the raw data

  $foo->Process ($data);

=cut

sub Process
{
    my $self = shift;
    my $data = shift;

    while (@{$data})
    {
        my ($code, $string) = next_item ($data);
        $self->{content} = decode_AutoCAD ($string) if ($code == 1);
        $self->{x} = $string if ($code == 10);
        $self->{y} = $string if ($code == 20);
        $self->{z} = $string if ($code == 30);
        $self->{height} = $string if ($code == 40);
        $self->{rotation} = $string if ($code == 50);
    }
}

sub Content
{
    my $self = shift;
    $self->{content} = shift || $self->{content};
    return $self->{content};
}

sub Height
{
    my $self = shift;
    $self->{height} = shift || $self->{height};
    return $self->{height};
}

sub Rotation
{
    my $self = shift;
    $self->{rotation} = shift || $self->{rotation};
    return $self->{rotation};
}


1;

