package File::DXF::Section;

use strict;
use warnings;
use Exporter;
use vars qw /@ISA @EXPORT_OK/;

@ISA = qw /Exporter/;
@EXPORT_OK = qw /next_item/;

=pod

Create one like so:

  $foo = new File::DXF::$bar;

=cut

sub new
{
    my $class = shift;
    $class = ref $class || $class;
    my $self = [];

    bless $self, $class;
    return $self;
}

=pod

Try and find some structure in the raw data

  $foo->Process ($data);

=cut

sub Process
{
    my $self = shift;
    my $data = shift;
}


sub next_item
{
    my $data = shift;
    my $item = shift @{$data};
    return @$item;
}


1;

